/* copyright-start
  ******************************************************************************
  *  Licensed Material - Property of IBM
  *
  *  5724-V27, 5655-R10, 5655-M22, 5655-L21, 5655-I49, 5655-D92
  *  Copyright IBM Corp. 1993, 2009                          
  *
  *  The source code for this program is not published or otherwise
  *  divested of its trade secrets, irrespective of what has been
  *  deposited with the U.S. Copyright Office.
  ******************************************************************************
  * copyright-end */

package com.ibm.dmh.rest.client;

import java.io.*;
import java.net.*;

import org.jdom.*;
import org.jdom.input.*;

public class DmhRestClient {
	protected Document doc = null;

	protected Document parseDoc(String uri, String user, String pswd) {
		doc = createDocument(uri, user, pswd);
		return doc;
	}

   
   /**
    * Simple implementation of the Authenticator API, used to pass
    * user/pw info in HTTP headers.
    */
   public static class RaaAuthenticator extends Authenticator {
      String user, pw;
      
      public RaaAuthenticator(String user, String pw) {
         this.user = user;
         this.pw = pw;
      }
      
      protected PasswordAuthentication getPasswordAuthentication() {
         return new PasswordAuthentication(user, pw.toCharArray());
      }  
   }  

	public static Document createDocument(String uri, String user, String pswd) {
		Document d = null;
	    // This builds a document of whatever's in the given resource
		SAXBuilder builder = new SAXBuilder();
		try {
         Authenticator.setDefault(new RaaAuthenticator(user, pswd));
         URL x = new URL(uri);
         URLConnection connection = x.openConnection();
         InputStream is = connection.getInputStream();
			d = builder.build(is);
		} catch (JDOMException e) {
			// TODO log the problem and ignore
			e.printStackTrace();
		} catch (IOException e) {
			// TODO log the problem and ignore
			e.printStackTrace();
		}
		return d;
	}

}
