/* copyright-start
  ******************************************************************************
  *  Licensed Material - Property of IBM
  *
  *  5724-V27, 5655-R10, 5655-M22, 5655-L21, 5655-I49, 5655-D92
  *  Copyright IBM Corp. 1993, 2009                          
  *
  *  The source code for this program is not published or otherwise
  *  divested of its trade secrets, irrespective of what has been
  *  deposited with the U.S. Copyright Office.
  ******************************************************************************
  * copyright-end */

package com.ibm.dmh.rest.client;

import java.util.*;

import org.jdom.*;
import org.jdom.filter.*;

public class DmhRestClientRoot extends DmhRestClient {

	private String dmhRestDetailsUri = null;
   private String raaUser = null;
   private String raaPswd = null;

	private DmhRestClientRoot() {
	}

	public DmhRestClientRoot(String raaRootUri, String user, String password) {
		dmhRestDetailsUri = raaRootUri;
      raaUser = user; 
      raaPswd = password;
   }

	@SuppressWarnings("unchecked")
	public List<Element> getSupportedTypes() {
		if (doc == null ) doc = parseDoc(dmhRestDetailsUri, raaUser, raaPswd);
		Filter f = new ElementFilter("types");
		// get element that encloses the links to relationships
		Element typesElement = (Element) doc.getRootElement().getDescendants(f).next();
		List<Element> types = typesElement.getChildren();
		return types;
	}

   public String[] getSupportedTypeNames() {
      List<Element> typeList = getSupportedTypes();
      String[] supportedTypeNames = new String[typeList.size()];
      for (int i = 0; i < supportedTypeNames.length; i++) {
         supportedTypeNames[i] = typeList.get(i).getText();          
      }
      return supportedTypeNames;
   }
   
}
