/* copyright-start
  ******************************************************************************
  *  Licensed Material - Property of IBM
  *
  *  5724-V27, 5655-R10, 5655-M22, 5655-L21, 5655-I49, 5655-D92
  *  Copyright IBM Corp. 1993, 2009                          
  *
  *  The source code for this program is not published or otherwise
  *  divested of its trade secrets, irrespective of what has been
  *  deposited with the U.S. Copyright Office.
  ******************************************************************************
  * copyright-end */

package com.ibm.dmh.rest.client;

/**
 * Given a uri to RAA xml REST service allow to retrieve paged list 
 * of RAA artifacts of a given type
 */
public class DmhRestClientSummary extends DmhRestClientPagedListOfLinks {
	private String dmhType = null;
	
	/**
     * Given a uri to RAA xml REST service allow to retrieve paged list 
     * of RAA artifacts of a given type
	 * @param dmhRestRootUri
	 * @param type
	 */
	public DmhRestClientSummary(String dmhRestRootUri, String type, String user, String pswd) {
		super(dmhRestRootUri, user, pswd);
		setDmhType(type);
		if (! dmhRestRootUri.endsWith("/") ) dmhRestRootUri = dmhRestRootUri + "/"; 
		dmhRestRootUri = dmhRestRootUri + type;
		setDmhPagedListOfLinksUri(dmhRestRootUri);      
	}

   /**
    * Given a uri to RAA xml REST service allow to retrieve paged list 
    * of RAA artifacts of a given type
    * @param dmhRestRootUri
    * @param type
    */
   public DmhRestClientSummary(String dmhRestSummaryUri, String user, String pswd) {
      super(dmhRestSummaryUri, user, pswd);
      setDmhPagedListOfLinksUri(dmhRestSummaryUri);
   }

   /**
	 * No default constructor - must be instantiated with uri and asset type name 
	 */	
//	private DmhRestClientSummary() {
//		throw new RuntimeException("Must be constructed with a uri of rest service provided");
//	}
		
	public String getDmhType() {
		return dmhType;
	}

	private void setDmhType(String dmhType) {
		this.dmhType = dmhType;
	}

	/**
	  * Tests for DmhRestClientSummary can be found at com.ibm.ram.test DmhRestClientSummary.java
	*/
	public static void main(String[] args) {
//		DmhRestClientSummary c = new DmhRestClientSummary("http://wsaa.svl.ibm.com:9080/dmhrest/xml", "Program");
//		// Iterate over all pages
//		while (c.nextPage()) {
//			List<Element> pgms = c.getPageArtifactElements();
//			for (Iterator iter = pgms.iterator(); iter.hasNext();) {
//				Element e = (Element) iter.next();
//				System.out.print(e.getText()+"="+e.getAttributeValue("href")+"\n");								
//			}			
//		}
	}

}
